%
% In this script I analize the independence of SPCA image coefficients
% achieved using different design criteria
%

% Lets use the transforms of blocks from the training set (1500 samples) 
% and from barbara (2500 samples)... enough to measure pairwise mutuals...
%  

clear all
close all
clc

%
% IMAGENES MCGILL CRITERIO 2
%

datos=[];
transf_2=[];
inversa_2=[];
for trozo=1:20
    load(['/media/disk/vista/Papers/aranyas/general_y_analiticas/general/TNN_2012_experiment2/transf_datos_imagenes_crit_2_trozo_',num2str(trozo)],'dat_test','pto_proximo_T2','R_T2');
    datos=[datos dat_test(:,1:length(R_T2(1,:)))];
    transf_2=[transf_2 R_T2];
    inversa_2=[inversa_2 pto_proximo_T2];
end


%
% IMAGENES MCGILL CRITERIO 3
%

datos3=[];
transf_3=[];
inversa_3=[];
for trozo=1:20
    load(['/media/disk/vista/Papers/aranyas/general_y_analiticas/general/TNN_2012_experiment2/transf_datos_imagenes_crit_3_trozo_',num2str(trozo)],'dat_test','pto_proximo_T2','R_T2');
    datos3=[datos3 dat_test(:,1:length(R_T2(1,:)))];
    transf_3=[transf_3 R_T2];
    inversa_3=[inversa_3 pto_proximo_T2];
end


%
% BARBARA CRITERIO 2
%

datosb=[];
transfb_2=[];
inversab_2=[];
%inversab_2_h=[];
for trozo=1:10
    load(['/media/disk/vista/Papers/aranyas/general_y_analiticas/general/TNN_2012_experiment2/transf_datos_barbara_crit_2_trozo_',num2str(trozo)],'dat_test','pto_proximo_T2','R_T2');
    datosb=[datosb dat_test(:,1:length(R_T2(1,:)))];
    transfb_2=[transfb_2 R_T2];
    inversab_2=[inversab_2 pto_proximo_T2];
    %l=length(pto_proximo_T2(1,:));
    %inversab_2_h=[inversab_2_h [pto_proximo_T2 zeros(4,250-l)]];
end

%
% BARBARA CRITERIO 3
%

datosb3=[];
transfb_3=[];
inversab_3=[];
%inversab_3_h=[];
for trozo=1:20
    load(['/media/disk/vista/Papers/aranyas/general_y_analiticas/general/TNN_2012_experiment2/transf_datos_barbara_crit_3_trozo_',num2str(trozo)],'dat_test','pto_proximo_T2','R_T2');
    datosb3=[datosb3 dat_test(:,1:length(R_T2(1,:)))];
    transfb_3=[transfb_3 R_T2];
    inversab_3=[inversab_3 pto_proximo_T2];
    %     l=length(pto_proximo_T2(1,:));
    %     if trozo<20
    %         inversab_3_h=[inversab_3_h [pto_proximo_T2 zeros(4,120-l)]];
    %     else
    %         inversab_3_h=[inversab_3_h [pto_proximo_T2 zeros(4,220-l)]];
    %     end
end

% %%%%%%%%%%%%%%%%%%%%%%%%%%% Lets merge images and Barbara data
% 
% %%%% Plots 1,2,3
% 
% figure,plot3(datos(1,:),datos(2,:),datos(3,:),'b.')
% hold on,plot3(datosb(1,:),datosb(2,:),datosb(3,:),'r.'),title('McGill (blue) and Barbara (red) Data')
% 
% figure,plot3(transf_2(1,:),transf_2(2,:),transf_2(3,:),'b.')
% hold on,plot3(transfb_2(1,:),transfb_2(2,:),transfb_2(3,:),'r.'),title('McGill (blue) and Barbara (red) transform (crit 2)')
% 
% figure,plot3(transf_3(1,:),transf_3(2,:),transf_3(3,:),'b.')
% hold on,plot3(transfb_3(1,:),transfb_3(2,:),transfb_3(3,:),'r.'),title('McGill (blue) and Barbara (red) transform (crit 3)')
% 
% %%%%% Plots 2,3,4
% 
% figure,plot3(datos(2,:),datos(3,:),datos(4,:),'b.')
% hold on,plot3(datosb(2,:),datosb(3,:),datosb(4,:),'r.'),title('McGill (blue) and Barbara (red) Data')
% 
% figure,plot3(transf_2(2,:),transf_2(3,:),transf_2(4,:),'b.')
% hold on,plot3(transfb_2(2,:),transfb_2(3,:),transfb_2(4,:),'r.'),title('McGill (blue) and Barbara (red) transform (crit 2)')
% 
% figure,plot3(transf_3(2,:),transf_3(3,:),transf_3(4,:),'b.')
% hold on,plot3(transfb_3(2,:),transfb_3(3,:),transfb_3(4,:),'r.'),title('McGill (blue) and Barbara (red) transform (crit 3)')
% 
% %  close all

%%%%% Merged data

data_pca = [datos datosb];
transform2 = [transf_2 transfb_2];
transform3 = [transf_3 transfb_3];

%%%%% Lets remove saturated data (they give rise to structure!)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dat=transform2;
good2 = find( abs(dat(2,:))<13.8 & abs(dat(3,:))<13.8 & abs(dat(4,:))<13.8 );
dat=transform3;
good3 = find( abs(dat(2,:))<13.8 & abs(dat(3,:))<13.8 & abs(dat(4,:))<13.8 );

transform2=transform2(:,good2);
transform3=transform3(:,good3);

% %%%% Plots 1,2,3
% 
% figure,plot3(datos(1,:),datos(2,:),datos(3,:),'b.')
% hold on,plot3(datosb(1,:),datosb(2,:),datosb(3,:),'r.'),title('McGill (blue) and Barbara (red) Data')
% 
% figure,plot3(transform2(1,1:2800),transform2(2,1:2800),transform2(3,1:2800),'b.')
% hold on,plot3(transform2(1,2801:end),transform2(2,2801:end),transform2(3,2801:end),'r.'),title('McGill (blue) and Barbara (red) transform (crit 2)')
% 
% figure,plot3(transform3(1,1:2800),transform3(2,1:2800),transform3(3,1:2800),'b.')
% hold on,plot3(transform3(1,2801:end),transform3(2,2801:end),transform3(3,2801:end),'r.'),title('McGill (blue) and Barbara (red) transform (crit 3)')

%%%%% Plots 2,3,4

figure(2),plot3(datos(2,:),datos(3,:),datos(4,:),'b.')
hold on,plot3(datosb(2,:),datosb(3,:),datosb(4,:),'r.'),box on,view([-64 10])
xlabel('C_2'),ylabel('C_3'),zlabel('C_4')
title({'PCA image coeffcients (non-zero frequency)';'McGill (blue) and Barbara (red) Data'})

figure(3),plot3(transform2(2,1:2800),transform2(3,1:2800),transform2(4,1:2800),'b.')
hold on,plot3(transform2(2,2801:end),transform2(3,2801:end),transform2(4,2801:end),'r.'),box on,view([-64 10])
xlabel('r_2'),ylabel('r_3'),zlabel('r_4')
title({'SPCA image coeffcients (infomax)';'McGill (blue) and Barbara (red)'})

figure(4),plot3(transform3(2,1:2800),transform3(3,1:2800),transform3(4,1:2800),'b.')
hold on,plot3(transform3(2,2801:end),transform3(3,2801:end),transform3(4,2801:end),'r.'),box on,view([-64 10])
xlabel('r_2'),ylabel('r_3'),zlabel('r_4')
title({'SPCA image coeffcients (error minimization)';'McGill (blue) and Barbara (red)'})


%%%%% Merged data in the input space (just to check)

load('/media/disk/vista/Papers/aranyas/general_y_analiticas/general/TNN_2012_experiment2/datos_e_inicializacion','m','V')

dat_m_pca = data_pca + repmat(m,1,size(data_pca,2));
data_x = V*dat_m_pca;

figure(1),plot3(data_x(1,1:3000),data_x(2,1:3000),data_x(3,1:3000),'b.')
hold on,plot3(data_x(1,3001:end),data_x(2,3001:end),data_x(3,3001:end),'r.'),box on,view([-26 10])
xlabel('x_1'),ylabel('x_2'),zlabel('x_3')
title({'Image coeffcients in the spatial domain';'(luminance in 3 neighbor pixels)';'McGill (blue) and Barbara (red)'})

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%%
%%  MUTUAL INFORMATION COMPUTATION
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Nbins=round(length(transform2(1,:)));   % 63

Nbins = 99;

for i=1:50  % I compute the mutual several times to obtain confidences
    
    if i==1
    disp(' ')
    disp('Computing mutual information (please wait...)')
    disp(' ')
    end
    
    elegidos = randperm(length(transform2(1,:)));
    elegidos = elegidos(1:end-800);
    
%%%% Spatial domain

     MIx(i) = mutual_information_4(data_x(1,elegidos),data_x(2,elegidos),Nbins);
     
%%%% PCA domain

     MI_pca_12(i) = mutual_information_4(data_pca(1,elegidos),data_pca(2,elegidos),Nbins);
     MI_pca_13(i) = mutual_information_4(data_pca(1,elegidos),data_pca(3,elegidos),Nbins);
     MI_pca_14(i) = mutual_information_4(data_pca(1,elegidos),data_pca(4,elegidos),Nbins);
     
     MI_pca_23(i) = mutual_information_4(data_pca(2,elegidos),data_pca(3,elegidos),Nbins);
     MI_pca_24(i) = mutual_information_4(data_pca(2,elegidos),data_pca(4,elegidos),Nbins);
     MI_pca_34(i) = mutual_information_4(data_pca(3,elegidos),data_pca(4,elegidos),Nbins);     

%%%% SPCA domain 2

     MI_spca2_12(i) = mutual_information_4(transform2(1,elegidos),transform2(2,elegidos),Nbins);
     MI_spca2_13(i) = mutual_information_4(transform2(1,elegidos),transform2(3,elegidos),Nbins);
     MI_spca2_14(i) = mutual_information_4(transform2(1,elegidos),transform2(4,elegidos),Nbins);
     
     MI_spca2_23(i) = mutual_information_4(transform2(2,elegidos),transform2(3,elegidos),Nbins);
     MI_spca2_24(i) = mutual_information_4(transform2(2,elegidos),transform2(4,elegidos),Nbins);
     MI_spca2_34(i) = mutual_information_4(transform2(3,elegidos),transform2(4,elegidos),Nbins);
     
%%%% SPCA domain 3

     MI_spca3_12(i) = mutual_information_4(transform3(1,elegidos),transform3(2,elegidos),Nbins);
     MI_spca3_13(i) = mutual_information_4(transform3(1,elegidos),transform3(3,elegidos),Nbins);
     MI_spca3_14(i) = mutual_information_4(transform3(1,elegidos),transform3(4,elegidos),Nbins);
     
     MI_spca3_23(i) = mutual_information_4(transform3(2,elegidos),transform3(3,elegidos),Nbins);
     MI_spca3_24(i) = mutual_information_4(transform3(2,elegidos),transform3(4,elegidos),Nbins);
     MI_spca3_34(i) = mutual_information_4(transform3(3,elegidos),transform3(4,elegidos),Nbins);
end     
     
     
%%%% MI RESULTS 

     MIx_m = mean(MIx);
     MIx_s = std(MIx);
     
     MI_pca_12_m = mean(MI_pca_12);
     MI_pca_13_m = mean(MI_pca_13); 
     MI_pca_14_m = mean(MI_pca_14);
     MI_pca_23_m = mean(MI_pca_23);
     MI_pca_24_m = mean(MI_pca_24);
     MI_pca_34_m = mean(MI_pca_34);
     MI_pca_12_s = std(MI_pca_12);
     MI_pca_13_s = std(MI_pca_13); 
     MI_pca_14_s = std(MI_pca_14);
     MI_pca_23_s = std(MI_pca_23);
     MI_pca_24_s = std(MI_pca_24);
     MI_pca_34_s = std(MI_pca_34);     
     
     
     MI_spca2_12_m = mean(MI_spca2_12);
     MI_spca2_13_m = mean(MI_spca2_13);
     MI_spca2_14_m = mean(MI_spca2_14);
     MI_spca2_23_m = mean(MI_spca2_23);
     MI_spca2_24_m = mean(MI_spca2_24);
     MI_spca2_34_m = mean(MI_spca2_34);
     MI_spca2_12_s = std(MI_spca2_12);
     MI_spca2_13_s = std(MI_spca2_13);
     MI_spca2_14_s = std(MI_spca2_14);
     MI_spca2_23_s = std(MI_spca2_23);
     MI_spca2_24_s = std(MI_spca2_24);
     MI_spca2_34_s = std(MI_spca2_34);

     MI_spca3_12_m = mean(MI_spca3_12);
     MI_spca3_13_m = mean(MI_spca3_13);
     MI_spca3_14_m = mean(MI_spca3_14);
     MI_spca3_23_m = mean(MI_spca3_23);
     MI_spca3_24_m = mean(MI_spca3_24);
     MI_spca3_34_m = mean(MI_spca3_34);
     MI_spca3_12_s = std(MI_spca3_12);
     MI_spca3_13_s = std(MI_spca3_13);
     MI_spca3_14_s = std(MI_spca3_14);
     MI_spca3_23_s = std(MI_spca3_23);
     MI_spca3_24_s = std(MI_spca3_24);     
     MI_spca3_34_s = std(MI_spca3_34);     
          
%      MIx_m
%      MIx_s
%      [MI_pca_12_m MI_pca_13_m MI_pca_14_m MI_pca_23_m MI_pca_24_m MI_pca_34_m]
%      [MI_pca_12_s MI_pca_13_s MI_pca_14_s MI_pca_23_s MI_pca_24_s MI_pca_34_s]
%      [MI_spca2_12_m MI_spca2_13_m MI_spca2_14_m MI_spca2_23_m MI_spca2_24_m MI_spca2_34_m]
%      [MI_spca2_12_s MI_spca2_13_s MI_spca2_14_s MI_spca2_23_s MI_spca2_24_s MI_spca2_34_s]
%      [MI_spca3_12_m MI_spca3_13_m MI_spca3_14_m MI_spca3_23_m MI_spca3_24_m MI_spca3_34_m]
%      [MI_spca3_12_s MI_spca3_13_s MI_spca3_14_s MI_spca3_23_s MI_spca3_24_s MI_spca3_34_m]
%      
%      MIx_m
%      [mean([MI_pca_12_m MI_pca_13_m MI_pca_14_m]) mean([MI_pca_23_m MI_pca_24_m MI_pca_34_m])]
%      [mean([MI_spca2_12_m MI_spca2_13_m MI_spca2_14_m]) mean([MI_spca2_23_m MI_spca2_24_m MI_spca2_34_m])]
%      [mean([MI_spca3_12_m MI_spca3_13_m MI_spca3_14_m]) mean([MI_spca3_23_m MI_spca3_24_m MI_spca3_34_m])]
% 
%      MIx_m
%      [mean([MI_pca_12_m MI_pca_13_m MI_pca_14_m  MI_pca_23_m MI_pca_24_m MI_pca_34_m])]
%      [mean([MI_spca2_12_m MI_spca2_13_m MI_spca2_14_m MI_spca2_23_m MI_spca2_24_m MI_spca2_34_m])]
%      [mean([MI_spca3_12_m MI_spca3_13_m MI_spca3_14_m MI_spca3_23_m MI_spca3_24_m MI_spca3_34_m])]
     
     
     disp('MI in the spatial domain (mean +- dev)')
     [MIx_m MIx_s]

     disp('MI in the PCA domain (AC components) (mean +- dev)')
     [mean([MI_pca_23_m MI_pca_24_m MI_pca_34_m]) mean([MI_pca_23_s MI_pca_24_s MI_pca_34_s])]
     
     disp('MI in the SPCA domain infomax (AC components) (mean +- dev)')
     [mean([MI_spca2_23_m MI_spca2_24_m MI_spca2_34_m]) mean([MI_spca2_23_s MI_spca2_24_s MI_spca2_34_s])]
     
     disp('MI in the SPCA domain errormin (AC components) (mean +- dev)')
     [mean([MI_spca3_23_m MI_spca3_24_m MI_spca3_34_m]) mean([MI_spca3_23_s MI_spca3_24_s MI_spca3_34_s])]

     
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%%
%%  CONDITIONAL PROBABILITIES (bow ties)
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% %%% All of them
% 
% [range1,range2,Px_2_1]=pajaritas2(data_x(1,:),data_x(2,:),[0 256],[0 256],61,'x',100,20);
% 
% [range1,range2,Pp_2_3]=pajaritas2(data_pca(2,:),data_pca(3,:),[-15 15],[-15 15],261,'C',101,20);
% [range1,range2,Pp_2_4]=pajaritas2(data_pca(2,:),data_pca(4,:),[-15 15],[-15 15],261,'C',102,20);
% [range1,range2,Pp_3_4]=pajaritas2(data_pca(3,:),data_pca(4,:),[-15 15],[-15 15],261,'C',103,20);
% 
% [range1,range2,Pr2_2_3]=pajaritas2(transform2(2,:),transform2(3,:),[-15 15],[-15 15],31,'r',104,20);
% [range1,range2,Pr2_2_4]=pajaritas2(transform2(2,:),transform2(4,:),[-15 15],[-15 15],31,'r',105,20);
% [range1,range2,Pr2_3_4]=pajaritas2(transform2(3,:),transform2(4,:),[-15 15],[-15 15],31,'r',106,20);
% 
% [range1,range2,Pr3_2_3]=pajaritas2(transform3(2,:),transform3(3,:),[-15 15],[-15 15],31,'r',107,20);
% [range1,range2,Pr3_2_4]=pajaritas2(transform3(2,:),transform3(4,:),[-15 15],[-15 15],31,'r',108,20);
% [range1,range2,Pr3_3_4]=pajaritas2(transform3(3,:),transform3(4,:),[-15 15],[-15 15],31,'r',109,20);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% selected

% MI measures
% MIx_m =
% 
%     1.6935
% 
% 
% MI_PCA =
% 
%     0.0410    0.1669
% 
% 
% MI_spca_2 =
% 
%     0.0826    0.0758
% 
% 
% MI_spca_3 =
% 
%     0.0486    0.0834
%
     
[range1,range2,Px_2_1]=pajaritas2(data_x(1,:),data_x(2,:),[0 256],[0 256],41,'x',100,22);
figure(gcf),title({'P(x_j|x_i) Spatial domain';[' MI = ',num2str(round(100*MIx_m)/100),' bits']},'fontsize',22)
%print(gcf,'-depsc2',...
%   ['/media/disk/vista/Papers/aranyas/general_y_analiticas/general/TNN_2012_experiment2/paja_x'])

[range1,range2,Pp_2_3]=pajaritas2(data_pca(2,:),data_pca(3,:),[-15 15],[-15 15],261,'C',101,22);
figure(gcf),title({'P(C_j|C_i) PCA domain';[' MI = ',num2str(round(100*MI_pca_23_m)/100),' bits']},'fontsize',22)
%print(gcf,'-depsc2',...
%   ['/media/disk/vista/Papers/aranyas/general_y_analiticas/general/TNN_2012_experiment2/paja_pca'])

[range1,range2,Pr2_2_4]=pajaritas2(transform2(2,:),transform2(4,:),[-15 15],[-15 15],31,'r',105,22);
figure(gcf),title({'P(r_j|r_i) SPCA infomax';[' MI = ',num2str(round(100*MI_spca2_24_m)/100),' bits']},'fontsize',22)
%print(gcf,'-depsc2',...
%   ['/media/disk/vista/Papers/aranyas/general_y_analiticas/general/TNN_2012_experiment2/paja_spca_infomax'])

[range1,range2,Pr3_2_4]=pajaritas2(transform3(2,:),transform3(4,:),[-15 15],[-15 15],31,'r',108,22);
figure(gcf),title({'P(r_j|r_i) SPCA errormin';[' MI = ',num2str(round(100*MI_spca3_24_m)/100),' bits']},'fontsize',22)
%print(gcf,'-depsc2',...
%   ['/media/disk/vista/Papers/aranyas/general_y_analiticas/general/TNN_2012_experiment2/paja_spca_errormin'])

tile
