function rq=scalar_quantization(r,M,N)

% SCALAR QUANTIZATION assumes the vector variable is zero mean and
% symmetric around the origin. It quantizes the vector on a reticle of size
% [+Mi -Mi] in each dimension i, with Ni nodes per dimension
%
% rq = scalar_quantization(r,[M1 M2 ... Md],[N1 N2 ... Nd]);
%
%    r = d*n matrix with n d-dimensional samples
%
%    M = 1*d vector with half the sizes of the reticle
%
%    N = 1*d vector with the number of quantization levels per dimension
%        (N is assumed to be odd).
%

[d,n]=size(r);

% rq = r./repmat(M',1,n);
% 
% rq = rq.*repmat((0.99999*(N-1).*(N./(N+1)))',1,n);
% 
% rq = round(rq);
% 
% rq = (rq./repmat((0.99999*(N-1).*(N./(N+1)))',1,n)).*repmat(M',1,n);

Nl=floor(N/2);
Nlm1=Nl+1;

f=0.999*0.5*(Nl+Nlm1);

f=repmat(f',1,n);

rq = r./repmat(M',1,n);

rq = (round(f.*rq)./f).*repmat(M',1,n);