function transform_image_data_criterion_3(A,destination_folder)

% TRANSFORM_IMAGE_DATA_CRITERION_3 transforms 2x2 patches from an image
% for further statistical analysis of coeffcient independence or transform coding.
% It uses metric criterion 3 (i.e. error minimization).
% It requieres prior initialization (see initialization_4d_texture_data.m)
% It saves the results in the file transformed_4d_image_crit_3.mat in the 
% destination_folder provided by the user.
%
% USE:
% transform_image_data_criterion_3(image,destination_folder)
% 
% where: 
%
%  * image = N*N matrix where N is even 
%  * destination_folder is the place where result is stored (a string like this):
%      destination_folder = '/SPCA/exp_metric_ICA_VQ/image_coding_real/data_coding/'

load('imagenes2x2_pca','dat','V','m');
load('initialization_4d_image_data','init_param3')

dat_barbara=im2col(A,[2 2],'distinct');
dat_barbara_pca = V'*dat_barbara;
dat_barbara_pca = dat_barbara_pca - repmat(m,1,size(dat_barbara_pca,2));
dat_test=dat_barbara_pca;

%% Tolerance (allowed error in the inverse)
tol=0.5;

%% Loop over samples to be transformed 
for nn=1:length(dat_test(1,:));
    tic
    [pto_proximo_T2(:,nn) R_T2(:,nn)]= spca_2(dat,dat_test(:,nn),init_param3,tol);
    save([destination_folder,'transformed_4d_image_crit_3'],'A','dat_test','pto_proximo_T2','R_T2');
    [nn toc]
end