%
% Starting point assumption
%
% This script reproduce the results regarding the starting point assumption
% shown in the manuscript.
% 
% The script compute the principal curve (PC) starting from different points. 
% Also secondary curves in different points of the PC are computed and shown.  
%
%
%

clear all
close all

tic
output_folder = '/media/disk/vista/Papers/aranyas/general_y_analiticas/general/TNN_2012_reproducible/exp_metric_ICA_VQ/spiral_synthetic/';

% addpath(genpath('/media/disk/vista/Papers/aranyas/general_y_analiticas/general/TNN_2012_reproducible'))


load([output_folder 'data_exp_Shrimp_2D'],'dat')

rand('seed',1234)
ind = randperm(size(dat,2));
dat_test = dat(:,ind(8001:end)); 
dat = dat(:,ind(1:8000));


LW = 3;
color = [0.8 0.2 0.2];


%% PARAMETERS

pto = [-2 -8.5]';

Nv = 1000;
tau = 1.2;
q = 0.05;

Btotal = 9;
Nbins = [400 100];

ddd = squareform((pdist(dat')));
ddd2 = ddd + eye(size(ddd,1))*(max(ddd(:)));
DIST =  max(min(ddd2));
tol = min(min(ddd2));
Nit = 25;

Aref = fliplr(eye(2));
a = 0.5;

%% SPCA 

criterion = 1;

[init_param] =  initialize_SPCA_2(dat,pto,Nv,tau,q,criterion,Btotal,Nbins,DIST,Aref);
    
figure,plot(dat(1,:),dat(2,:),'.','markersize',0.1), axis square, axis equal
plot_axes(init_param,3,1)
    
%% 

aux = init_param.eucl_PC;
PC = cat(2,aux.pto);

for nn=1:size(PC,2)
    [RES(nn).init_param] =  initialize_SPCA_2(dat,init_param.eucl_PC(nn).pto,Nv,tau,q,criterion,Btotal,Nbins,DIST,init_param.eucl_PC(nn).V_der);
%     figure,plot(dat(1,:),dat(2,:),'.','markersize',0.1), axis square, axis equal
%     plot_axes(RES(nn).init_param,3,1)
    nn
end

save

POINTS = [5 26:4:34];

for ind_p = 1:length(POINTS)
    
    
    figure,plot(dat(1,:),dat(2,:),'.','markersize',0.1), axis square, axis equal
    plot_axes(RES(POINTS(ind_p)).init_param,3,1)
    hold on
    for nn=1:size(PC,2)
        eje = RES(nn).init_param.eucl_PCs(2).eje;
        plotea_eje(eje,'k-',1)
    end 
end

toc

