
clear all
close all

addpath(genpath('/media/disk/vista/Papers/aranyas/general_y_analiticas/general/TNN_2012_reproducible'))
output_folder = '/media/disk/vista/Papers/aranyas/general_y_analiticas/general/TNN_2012_reproducible/exp_metric_ICA_VQ/spiral_synthetic/';
load([output_folder 'data_exp_Shrimp_2D'],'dat')

rand('seed',1234)
ind = randperm(size(dat,2));
dat_test = dat(:,ind(8001:end));
dat = dat(:,ind(1:8000));

LW = 3;
color = [0.8 0.2 0.2];

%% PARAMETERS

pto = [-2 -8.5]';
Nv = 1000;
tau = 1.2;
q = 0.05;

Btotal = 9;
Nbins = [400 100];
ddd = squareform((pdist(dat')));
ddd2 = ddd + eye(size(ddd,1))*(max(ddd(:)));
DIST =  max(min(ddd2));
tol = min(min(ddd2));
Nit = 1000;
clear ddd ddd2

Aref = fliplr(eye(2));
NNB = 100;
QQQ = round(sqrt(NNB).*Nbins./sqrt(prod(Nbins)));
a = 0.5;
facty = 0.8;

%% SPCA WITH DIFFERENT CRITERIA

for criterion = 1:3
    
%     [RES(criterion).init_param] =  initialize_SPCA_2(dat,pto,Nv,tau,q,criterion,Btotal,Nbins,DIST,Aref);
%     figure,plot(dat(1,:),dat(2,:),'.','markersize',0.1), axis square, axis equal
%     plot_axes(RES(criterion).init_param,3,1)
%     
%     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     for nn = 1:size(dat_test,2)
%         tic
%         [RES(criterion).pto_prox2(:,nn) RES(criterion).R2(:,nn) RES(criterion).pto_prox1(:,nn) RES(criterion).R1(:,nn)] ...
%             = spca_2(dat,dat_test(:,nn),RES(criterion).init_param,tol,Nit);
%         [nn toc]
%     end
%     RES(criterion).er = sum(abs(RES(criterion).pto_prox2-dat_test(:,1:size(RES(criterion).pto_prox2,2))));
%    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%
    %%   VECTOR QUANTIZATION:
    %%
    %%   Codebook design takes about 1.5 secs/codevector (in a Dell PowerEdge2900 processor with 2GB RAM)
    %%   Quantization time is negligible
    %%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % CODEBOOK DESIGN (regular lattice in the transformed domain)
    %
    % dom_QR1 = regular lattice on the transform domain
    ii = find(QQQ/2-round(QQQ/2)==0);
    QQQ(ii) = QQQ(ii)+1;
   
    mm = min(RES(criterion).R2(1,:))-0.00001;
    MM = max(RES(criterion).R2(1,:))+0.00001;
    aux = linspace(mm,MM,2*QQQ(1)+1);
    fact1_R1 = aux(2:2:end);
    
    MM = facty*max(abs(RES(criterion).R2(2,:)));
    mm = -MM;
    aux = linspace(mm,MM,2*QQQ(2)+1);
    fact2_R1 = aux(2:2:end);
    [X Y] = meshgrid(fact1_R1,fact2_R1);
   
    RES(criterion).dom_QR1 = [X(:)'; Y(:)'];

   
    %
    %     figure,
    %     hold on,
    %     reticula(RES(criterion).dom_QR1,QQQ(1),QQQ(2),LW,color,0)
    %     plot(RES(criterion).dom_QR1(1,:),RES(criterion).dom_QR1(2,:),'r.'),axis equal
    %     plot(RES(criterion).R2(1,:),RES(criterion).R2(2,:),'.','markersize',10)
    % CODEBOOK IN THE INPUT SPACE (inverse of the regular lattice)
    % inv_dom_QR1 = non-uniform lattice in the input domain
    clear inv_dom_QR1
    for nn=1:size(RES(criterion).dom_QR1,2)
        tic
        [RES(criterion).inv_dom_QR1(:,nn), AA] = inv_SPCA_2(dat, RES(criterion).dom_QR1(:,nn), RES(criterion).init_param);
        [nn toc]
    end
    
    % QUANTIZATION OF TRAINING DATA AND TEST DATA
    for nnn = 1:size(dat,2)
        aux = sum((RES(criterion).inv_dom_QR1-repmat(dat(:,nnn),1,size(RES(criterion).inv_dom_QR1,2))).^2);
        [mm in] = min(aux);
        RES(criterion).dat_QR1(:,nnn) = RES(criterion).inv_dom_QR1(:,in);
    end
    
    for nnn = 1:size(dat_test,2)
        aux = sum((RES(criterion).inv_dom_QR1-repmat(dat_test(:,nnn),1,size(RES(criterion).inv_dom_QR1,2))).^2);
        [mm in] = min(aux);
        RES(criterion).dat_QR1_test(:,nnn) = RES(criterion).inv_dom_QR1(:,in);
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % MUTUAL INFORMATION
    [RES(criterion).MI_SPCA] = mutual_information_4(RES(criterion).R2(1,:),RES(criterion).R2(2,:),a*sqrt(size(RES(criterion).R2,2)));
    % RMSE
    RES(criterion).ER_R_SPCA = rmse(dat,RES(criterion).dat_QR1);
    RES(criterion).ER_R_test_SPCA = rmse(dat_test,RES(criterion).dat_QR1_test);
    
    save([output_folder 'TNN_shrimp_experiment_results_tau_1_2'],'RES')
end


%% UNIFORM QUANTIZATION IN THE


% ORIGINAL DOMAIN (WITH THE SAME CODEBOOK SIZE)
Nbb = prod(QQQ);
datic = dat;
alpha = sqrt((max(datic(1,:))-min(datic(1,:)))*(max(datic(2,:))-min(datic(2,:)))/Nbb);
Q1 = round((max(datic(1,:))-min(datic(1,:)))/alpha);
Q2 = round((max(datic(2,:))-min(datic(2,:)))/alpha);

mm = min(datic(1,:))-0.00001;
MM = max(datic(1,:))+0.00001;
fact = (datic(1,:)-mm)/(MM-mm);
Q_datic(1,:) = ((round(Q1*fact-0.5)+0.5)/Q1)*(MM-mm)+mm;

mm = min(datic(2,:))-0.00001;
MM = max(datic(2,:))+0.00001;
fact2 = (datic(2,:)-mm)/(MM-mm);
Q_datic(2,:) = ((round(Q2*fact2-0.5)+0.5)/Q2)*(MM-mm)+mm;

%%%
Nbb = prod(QQQ);
datic = dat_test;

mm = min(datic(1,:))-0.00001;
MM = max(datic(1,:))+0.00001;
fact = (datic(1,:)-mm)/(MM-mm);
Q_datic_test(1,:) = ((round(Q1*fact-0.5)+0.5)/Q1)*(MM-mm)+mm;

mm = min(datic(2,:))-0.00001;
MM = max(datic(2,:))+0.00001;
fact2 = (datic(2,:)-mm)/(MM-mm);
Q_datic_test(2,:) = ((round(Q2*fact2-0.5)+0.5)/Q2)*(MM-mm)+mm;

% MUTUAL INFORMATION
[MI_x] = mutual_information_4(dat_test(1,:),dat_test(2,:),a*sqrt(size(dat,2)));

% RMSE
ER_x = rmse(dat,Q_datic);
ER_x_test = rmse(dat_test,Q_datic_test);


%% PLOTING RESULTS

%% Original Domain
figure
plot(dat_test(1,:),dat_test(2,:),'.')
hold on, plot(Q_datic_test(1,:),Q_datic_test(2,:),'r.','markersize',10)
axis equal

figure
plot(dat_test(1,:),dat_test(2,:),'.')
hold on, plot(RES(1).inv_dom_QR1(1,:),RES(1).inv_dom_QR1(2,:),'r.','markersize',10)
axis equal

figure
plot(dat_test(1,:),dat_test(2,:),'.')
hold on, plot(RES(2).inv_dom_QR1(1,:),RES(2).inv_dom_QR1(2,:),'r.','markersize',10)
axis equal

figure
plot(dat_test(1,:),dat_test(2,:),'.')
hold on, plot(RES(3).inv_dom_QR1(1,:),RES(3).inv_dom_QR1(2,:),'r.','markersize',10)
axis equal

%% Transform Domain
figure
plot(RES(1).R2(1,:),RES(1).R2(2,:),'.')
hold on, plot(RES(1).dom_QR1(1,:),RES(1).dom_QR1(2,:),'r.','markersize',10)
axis equal

figure
plot(RES(2).R2(1,:),RES(2).R2(2,:),'.')
hold on, plot(RES(2).dom_QR1(1,:),RES(2).dom_QR1(2,:),'r.','markersize',10)
axis equal

figure
plot(RES(3).R2(1,:),RES(3).R2(2,:),'.')
hold on, plot(RES(3).dom_QR1(1,:),RES(3).dom_QR1(2,:),'r.','markersize',10)
axis equal

%% MI results
[MI_x cat(1,RES(1:3).MI_SPCA)']

%% RMSE training data results
[ER_x cat(1,RES(1:3).ER_R_SPCA)']

%% RMSE test data results
[ER_x_test cat(1,RES(1:3).ER_R_test_SPCA)']
save([output_folder 'TNN_shrimp_experiment_results'],'RES')


