
clear all
close all

destino = '/media/disk/vista/Papers/aranyas/general_y_analiticas/general/NECO_2011_experiments/cuerno_reproducible_results/';

LW = 1;
color = 0.6*ones(1,3);

for criterion =2:3    %1:3
     
    factx1 = 1.05;
    factx2 = 1.1;
    facty = 1.2;

    CRIT = criterion;
    if CRIT == 1
        filename = ['cuerno_derecho_SPC_7_param_buenos_crit_',num2str(CRIT) '_prueba'];
    else
        filename = ['cuerno_derecho_SPC_7_param_buenos_crit_',num2str(CRIT) '_prueba_2'];
    end
    
    load([destino filename])

    [Aref, dist_fuera, Nbins, eje_principal, eje_principal_sin_modA] = inicializa_RN_4(pto,Nv,dist_fuera,Btotal,1,muelle);


    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%
    %%   VECTOR QUANTIZATION:
    %%
    %%   Codebook design takes about 1.5 secs/codevector (in a Dell PowerEdge2900 processor with 2GB RAM) for the parameters used here
    %%   Quantization time is negligible
    %%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    % CODEBOOK DESIGN (regular lattice in the transformed domain)
    %

    % dom_QR1 = regular lattice on the transform domain

    QQQ = round(sqrt(NNB).*Nbins./sqrt(prod(Nbins)));

    ii = find(QQQ/2-round(QQQ/2)==0);
    QQQ(ii) = QQQ(ii)+1;

    R1 = R2;
    mm = min(R1(1,:))-0.00001;
    MM = max(R1(1,:))+0.00001;
    aux = linspace(factx1*mm,factx2*MM,2*QQQ(1)+1);
    fact1_R1 = aux(2:2:end);

    MM = facty*max(abs(R1(2,:)));
    mm = -MM;
    aux = linspace(mm,MM,2*QQQ(2)+1);
    fact2_R1 = aux(2:2:end);

    [X Y] = meshgrid(fact1_R1,fact2_R1);
    clear dom_QR1
    dom_QR1(1,:) = X(:);
    dom_QR1(2,:) = Y(:);

    figure,
    hold on,
    reticula(dom_QR1,QQQ(1),QQQ(2),LW,color,0)
    plot(dom_QR1(1,:),dom_QR1(2,:),'r.'),axis equal
    plot(R2(1,:),R2(2,:),'.','markersize',10)


    % CODEBOOK IN THE INPUT SPACE (inverse of the regular lattice)

    % inv_dom_QR1 = non-uniform lattice in the input domain
    criterio=CRIT;

    % [Aref2, dist_fuera, Nbins2, eje_principal, eje_principal_sin_modD] = inicializa_RN_3(pto,Nv,dist_fuera,Btotal,0,muelle,Aref);


    global pto_proximo_principal_CRIT
    global resp_principal_CRIT
    global eje_CRIT

    eje_principal = eje_CRIT;
    pto_proximo_principal = pto_proximo_principal_CRIT;
    resp_principal = resp_principal_CRIT;

    clear inv_dom_QR1
    for nn=1:size(dom_QR1,2)
        tic
        [inv_dom_QR1(:,nn),AA] = inv_respuesta_RN_3(dom_QR1(:,nn),pto,Aref,Nbins,Nv,muelle);
        [nn toc]
    end

    % QUANTIZATION OF TRAINING DATA AND TEST DATA

    for nnn = 1:N_datos
        aux = sum((inv_dom_QR1-repmat(dat(:,nnn),1,size(inv_dom_QR1,2))).^2);
        [mm in] = min(aux);
        dat_QR1(:,nnn) = inv_dom_QR1(:,in);
    end

    for nnn = 1:N_samples
        aux = sum((inv_dom_QR1-repmat(dat_test(:,nnn),1,size(inv_dom_QR1,2))).^2);
        [mm in] = min(aux);
        dat_QR1_test(:,nnn) = inv_dom_QR1(:,in);
    end


    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% UNIFORM QUANTIZATION IN THE
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ORIGINAL DOMAIN (WITH THE SAME CODEBOOK SIZE)

    Nbb = prod(QQQ);
    datic = dat;
    alpha = sqrt((max(datic(1,:))-min(datic(1,:)))*(max(datic(2,:))-min(datic(2,:)))/Nbb);

    Q1 = round((max(datic(1,:))-min(datic(1,:)))/alpha);
    Q2 = round((max(datic(2,:))-min(datic(2,:)))/alpha);

    mm = min(datic(1,:))-0.00001;
    MM = max(datic(1,:))+0.00001;

    fact = (datic(1,:)-mm)/(MM-mm);
    Q_datic(1,:) = ((round(Q1*fact-0.5)+0.5)/Q1)*(MM-mm)+mm;

    mm = min(datic(2,:))-0.00001;
    MM = max(datic(2,:))+0.00001;

    fact2 = (datic(2,:)-mm)/(MM-mm);
    Q_datic(2,:) = ((round(Q2*fact2-0.5)+0.5)/Q2)*(MM-mm)+mm;

    %%%

    Nbb = prod(QQQ);
    datic = dat_test;
    alpha = sqrt((max(datic(1,:))-min(datic(1,:)))*(max(datic(2,:))-min(datic(2,:)))/Nbb);

    Q1 = round((max(datic(1,:))-min(datic(1,:)))/alpha);
    Q2 = round((max(datic(2,:))-min(datic(2,:)))/alpha);

    mm = min(datic(1,:))-0.00001;
    MM = max(datic(1,:))+0.00001;

    fact = (datic(1,:)-mm)/(MM-mm);
    Q_datic_test(1,:) = ((round(Q1*fact-0.5)+0.5)/Q1)*(MM-mm)+mm;

    mm = min(datic(2,:))-0.00001;
    MM = max(datic(2,:))+0.00001;

    fact2 = (datic(2,:)-mm)/(MM-mm);
    Q_datic_test(2,:) = ((round(Q2*fact2-0.5)+0.5)/Q2)*(MM-mm)+mm;


    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    % MUTUAL INFORMATION
    a=0.5;
    [MI_ori] = mutual_information_4(dat_test(1,:),dat_test(2,:),a*sqrt(size(dat,2)));
    [MI_trans1] = mutual_information_4(R1(1,:),R1(2,:),a*sqrt(size(R1,2)));

    % HSIC
    params.sigx=-1;params.sigy=-1; [theta,HSIC_ori,pvalue] = hsic(dat_test(1,:)',dat_test(2,:)',0.05,params)
    params.sigx=-1;params.sigy=-1; [theta,HSIC_trans1,pvalue] = hsic(R1(1,:)',R1(2,:)',0.05,params)

    % RMSE

    ER_x = rmse(dat,Q_datic);
    ER_x_test = rmse(dat_test,Q_datic_test);

    ER_R1 = rmse(dat,dat_QR1);
    ER_R1_test = rmse(dat_test,dat_QR1_test);

    mutuals=[MI_ori MI_trans1];
    hsics = [HSIC_ori HSIC_trans1];
    errores_tot=[ER_x ER_R1];
    errores_test=[ER_x_test ER_R1_test];

    figure,plot(dat(1,:),dat(2,:),'.','markersize',0.1)
    hold on,plot(Q_datic(1,:),Q_datic(2,:),'r.'),axis equal
    hold on,plot(inv_dom_QR1(1,:),inv_dom_QR1(2,:),'c.'),axis equal
    hold on,plot(inv_dom_QR1(1,:),inv_dom_QR1(2,:),'ko'),axis equal
    reticula(inv_dom_QR1,QQQ(1),QQQ(2),LW,color)


    save([destino 'reretic_' filename])
end

