
clear all
close all


load(['data_exp_Shrimp_2D'],'dat')

rand('seed',1234)
ind = randperm(size(dat,2));
dat_test = dat(:,ind(8001:end));
dat = dat(:,ind(1:8000));


load(['results_exp_shrimp_ICA_vs_VQ'],'RES')

%% PLOTING RESULTS

%% Original Domain

figure
plot(dat_test(1,:),dat_test(2,:),'.')
hold on, plot(RES(1).inv_dom_QR1(1,:),RES(1).inv_dom_QR1(2,:),'r.','markersize',10)
axis equal
title({'Original domain SPCA g = 0' ; 'Centroids red'})

figure
plot(dat_test(1,:),dat_test(2,:),'.')
hold on, plot(RES(2).inv_dom_QR1(1,:),RES(2).inv_dom_QR1(2,:),'r.','markersize',10)
axis equal
title({'Original domain SPCA g = 1' ; 'Centroids red'})

figure
plot(dat_test(1,:),dat_test(2,:),'.')
hold on, plot(RES(3).inv_dom_QR1(1,:),RES(3).inv_dom_QR1(2,:),'r.','markersize',10)
axis equal
title({'Original domain SPCA g = 1/3' ; 'Centroids red'})

%% Transform Domain
figure
plot(RES(1).R2(1,:),RES(1).R2(2,:),'.')
hold on, plot(RES(1).dom_QR1(1,:),RES(1).dom_QR1(2,:),'r.','markersize',10)
axis equal
title({'Transformed domain SPCA g = 0' ; 'Centroids red'})

figure
plot(RES(2).R2(1,:),RES(2).R2(2,:),'.')
hold on, plot(RES(2).dom_QR1(1,:),RES(2).dom_QR1(2,:),'r.','markersize',10)
axis equal
title({'Transformed domain SPCA g = 1' ; 'Centroids red'})

figure
plot(RES(3).R2(1,:),RES(3).R2(2,:),'.')
hold on, plot(RES(3).dom_QR1(1,:),RES(3).dom_QR1(2,:),'r.','markersize',10)
axis equal
title({'Transformed domain SPCA g = 1/3' ; 'Centroids red'})

%% Numbers

disp('  ')
disp('  ')
disp(' NUMBERS ')
disp('  ')
disp('       g = 0      g = 1       g = 1/3') 
disp(['MI:    ' num2str((1/1000)*round(cat(1,RES(1:3).MI_SPCA)'*1000))])
disp(['RMSE:  ' num2str((1/1000)*round(cat(1,RES(1:3).ER_R_test_SPCA)'*1000))])
disp('  ')
disp('  ')


tile